signature GENERIC_PUZZLE =
sig
 type external_state
 type internal_state
 val sameState: (internal_state * internal_state) -> bool
 val hashState: (internal_state -> int)
 type puzzle_parameter
 val mkInstance: puzzle_parameter -> 
                  { decode   : (internal_state -> external_state),
                    encode   : (external_state -> internal_state),
                    successor: (internal_state -> internal_state list),
                    initialStates: internal_state list,
                    randomStatePair : unit -> (external_state * external_state)
                   }
end ;

