
   
(* R. Holte, May 11, 1994.
   Put together S1 and S2  if S2 is the only successor of S1 and S1 is
   the only successor of S2.

*)

functor AbsGeneratorLineFUN (structure Graph : GRAPH) : ABSGEN  =

 (* LINES ... a specialization of CHAINS *)
 (* Make classes that are chains of successors.
    The first node in the given list serves as the starting point
    of the chain.  If it has a unique successor then add that succesor
    to the chain and carry on from there.  Stop when the current node
    has either has >1 successors or >1 predecessors or is part of some
    other class.
    
    As with the other abstraction methods, returns a triple of:
            the set of nodes to be combined,
            the list without the first node of this set and
            the abstract type is returned.
 *)
 
struct

structure Graph = Graph

local open Graph Random in

type CONDITIONparameter = unit
type ACTIONparameter    = unit

  fun nth_nonStop _ answer [] = answer
   | nth_nonStop count sofar (Node{flag= ref Stop,...}::tail) =
                       nth_nonStop (count-1) sofar tail
   | nth_nonStop count  _  (n::tail) = 
           if (count <= 1)
           then  (SOME n)
           else nth_nonStop (count-1) (SOME n) tail


 fun make_line ((n as (Node{flag,preds,succs,...}))::ns) =
  (flag := Stop ;
   if (length 

(******************* HERE *************************)


 fun ACTION _ ((thisNode as (Node{flag,succs,...}))::ns) = 
 case (!succs) of
  of   [s] => (flag := Stop ; ( thisNode::(make_line s), ns, Line ) )
  |     _  => ([thisNode], ns, Another)
 end

 fun CONDITION _ _ = true    (* Always apply this generator
                                if it is in the function list *)

end
end
